#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>
#asm
   .equ __w1_port=0x18 ;PORTB
   .equ __w1_bit=2
#endasm
#include <1wire.h>
#include <ds18b20.h>
int temper;


int number = 0;
int number1 = 0;
int number2 = 0;
int i=0;

// Timer 1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
        PORTB.0=0;
        PORTB.1=0;
        if(i==0)
        {
           number=number1;
           PORTB.1=1;
           i++;
        }
        else
        {
           number=number2;
           PORTB.0=1;
           i=0;
        }


        switch(number)
        {
         case 0:{PORTD=0xC0; break;}
         case 1:{PORTD=0xF9; break;}
         case 2:{PORTD=0xA4; break;}
         case 3:{PORTD=0xB0; break;}
         case 4:{PORTD=0x99; break;}
         case 5:{PORTD=0x92; break;}
         case 6:{PORTD=0x82; break;}
         case 7:{PORTD=0xF8; break;}
         case 8:{PORTD=0x80; break;}
         case 9:{PORTD=0x90; break;}
        }



}

void main(void)
{



PORTB=0xFF;
DDRB=0xFF;

PORTD=0xC0;
DDRD=0xFF;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: CTC top=OCR1A
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
TCCR1A=0x00;
TCCR1B=0x0A;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x10;
OCR1AL=0x46;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x10;
w1_init();
// Global enable interrupts
#asm("sei")

while (1)
      {

          temper=ds18b20_temperature(0);
          if (temper>1000)
          {
             temper=4096.0-temper;
             temper=-temper;
          }
          number1= temper/10;
          number2= temper%10;
          delay_ms(1500);
      };
}















